]> git.ipfire.org Git - people/ms/network.git/blame - src/functions/functions.zone
zone: change edit syntax for config.
[people/ms/network.git] / src / functions / functions.zone
CommitLineData
1848564d
MT
1#!/bin/bash
2###############################################################################
3# #
4# IPFire.org - A linux based firewall #
5# Copyright (C) 2010 Michael Tremer & Christian Schmidt #
6# #
7# This program is free software: you can redistribute it and/or modify #
8# it under the terms of the GNU General Public License as published by #
9# the Free Software Foundation, either version 3 of the License, or #
10# (at your option) any later version. #
11# #
12# This program is distributed in the hope that it will be useful, #
13# but WITHOUT ANY WARRANTY; without even the implied warranty of #
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
15# GNU General Public License for more details. #
16# #
17# You should have received a copy of the GNU General Public License #
18# along with this program. If not, see <http://www.gnu.org/licenses/>. #
19# #
20###############################################################################
21
1c6a4e30 22zone_dir() {
1848564d
MT
23 local zone=${1}
24
d2a21d01 25 echo "${NETWORK_ZONE_DIR}/zones/${zone}"
1848564d
MT
26}
27
1c6a4e30 28zone_exists() {
1848564d 29 local zone=${1}
711ffac1
MT
30 assert isset zone
31
1848564d
MT
32 [ -d "$(zone_dir ${zone})" ]
33}
34
1c6a4e30 35zone_match() {
1848564d
MT
36 local match
37
38 local i
39 for i in ${VALID_ZONES}; do
40 match="${match}|${i}[0-9]{1,5}"
41 done
42
43 echo "${match:1:${#match}}"
44}
45
1c6a4e30 46zone_name_is_valid() {
1848564d 47 local zone=${1}
4fedddef
MT
48
49 # Don't accept empty strings.
50 [ -z "${zone}" ] && return ${EXIT_FALSE}
711ffac1 51
1848564d
MT
52 [[ ${zone} =~ $(zone_match) ]]
53}
54
1c6a4e30 55zone_is_local() {
1848564d
MT
56 local zone=${1}
57
7de0637a 58 [[ "${zone:0:${#ZONE_LOCAL}}" = "${ZONE_LOCAL}" ]]
5e42d659
MT
59}
60
1c6a4e30 61zone_is_nonlocal() {
5e42d659
MT
62 local zone=${1}
63
7de0637a 64 [[ "${zone:0:${#ZONE_NONLOCAL}}" = "${ZONE_NONLOCAL}" ]]
1848564d
MT
65}
66
1c6a4e30 67zone_get_hook() {
1848564d 68 local zone=${1}
711ffac1
MT
69 assert isset zone
70
1848564d
MT
71 config_get_hook $(zone_dir ${zone})/settings
72}
73
1c6a4e30 74zone_start() {
5bb2429a
MT
75 # This function will bring up the zone
76 # 'asynchronously' with help of systemd.
77
78 local zone=${1}
79 assert zone_exists ${zone}
80
1d08b9b3 81 service_start "network@${zone}.service"
5bb2429a
MT
82}
83
1c6a4e30 84zone_start_auto() {
2a969c27
MT
85 local zone="${1}"
86 assert zone_exists "${zone}"
87
88 # If the zone has already been started, we
89 # will reload it so the current configuration
90 # is re-applied.
91 if zone_is_active "${zone}"; then
92 zone_reload "${zone}"
93 return ${?}
94
95 # If the zone is still down, but in auto-start mode,
96 # we will start it.
97 elif zone_is_enabled "${zone}"; then
98 zone_start "${zone}"
99 return ${?}
100 fi
101
102 # Otherwise, nothing will be done.
103 return ${EXIT_OK}
104}
105
1c6a4e30 106zone_stop() {
5bb2429a
MT
107 # This function will bring down the zone
108 # 'asynchronously' with help of systemd.
109
110 local zone=${1}
111 assert zone_exists ${zone}
112
1d08b9b3 113 service_stop "network@${zone}.service"
5bb2429a
MT
114}
115
1c6a4e30 116zone_reload() {
e6fd23fd
MT
117 local zone="${1}"
118 assert zone_exists "${zone}"
119
120 service_reload "network@${zone}.service"
121}
122
1c6a4e30 123zone_hotplug_event() {
fb8c7c92 124 local zone="${1}"
2a969c27 125 assert isset zone
fb8c7c92 126
2a969c27 127 hotplug_assert_in_hotplug_event
fb8c7c92 128
2a969c27 129 zone_cmd "hotplug" "${zone}"
fb8c7c92
MT
130}
131
1c6a4e30 132zone_enable() {
5c5b8e36
SS
133 # This function will enable the zone
134 # with help of systemd.
135
136 local zone="${1}"
137 assert zone_exists "${zone}"
138
139 # Enable service for the zone
140 service_enable "network@${zone}.service"
141 local ret=$?
142
143 if [ ${ret} -eq ${EXIT_OK} ]; then
144 log INFO "Auto-start enabled for zone ${zone}"
145 return ${EXIT_OK}
146 fi
147
148 log ERROR "Could not enable zone ${zone}: ${ret}"
149 return ${ret}
150}
151
1c6a4e30 152zone_disable() {
5c5b8e36
SS
153 # This function will disable the zone
154 # with help of systemd.
155
156 local zone="${1}"
157 assert zone_exists "${zone}"
158
159 # Disable service for the zone
160 service_disable "network@${zone}.service"
161 local ret=$?
162
163 if [ ${ret} -eq ${EXIT_OK} ]; then
164 log INFO "Auto-start disabled for zone ${zone}"
165 return ${EXIT_OK}
166 fi
167
168 log ERROR "Could not disable zone ${zone}: ${ret}"
169 return ${ret}
170}
171
1c6a4e30 172zone_is_enabled() {
5c5b8e36
SS
173 local zone="${1}"
174 assert isset zone
175
176 # Ask systemd if the zone is enabled.
177 if service_is_enabled "network@${zone}.service"; then
178 return ${EXIT_TRUE}
179 fi
180
181 return ${EXIT_FALSE}
182}
183
1c6a4e30 184zone_is_active() {
e6fd23fd
MT
185 local zone="${1}"
186 assert isset zone
187
188 if service_is_active "network@${zone}.service"; then
189 return ${EXIT_TRUE}
190 fi
191
192 return ${EXIT_FALSE}
193}
194
1c6a4e30 195zone_is_enabled_or_active() {
2a969c27
MT
196 local zone="${1}"
197 assert isset zone
198
199 zone_is_enabled "${zone}" || zone_is_active "${zone}"
200}
201
1c6a4e30 202zone_cmd() {
2a969c27
MT
203 local cmd="${1}"
204 local port="${2}"
205 shift 2
206
207 assert isset cmd
208 assert isset zone
209
210 local hook="$(zone_get_hook ${zone})"
211 assert isset hook
212
213 hook_exec zone "${hook}" "${cmd}" "${zone}" $@
214}
215
1c6a4e30 216zone_new() {
1848564d
MT
217 local zone=${1}
218 local hook=${2}
219 shift 2
220
221 if ! zone_name_is_valid ${zone}; then
222 error "Zone name '${zone}' is not valid."
223 return ${EXIT_ERROR}
224 fi
225
226 if zone_exists ${zone}; then
227 error "Zone '${zone}' does already exist."
228 return ${EXIT_ERROR}
229 fi
230
d61a01d4 231 if ! hook_zone_exists ${hook}; then
1848564d
MT
232 error "Hook '${hook}' does not exist."
233 return ${EXIT_ERROR}
234 fi
235
236 mkdir -p $(zone_dir ${zone})
237
a5ebb169
MT
238 # Create directories for configs and ports
239 mkdir -p $(zone_dir ${zone})/{configs,ports}
943e3f7e 240
cf0fc8ab 241 hook_zone_exec "${hook}" "new" "${zone}" $@
1848564d
MT
242 local ret=$?
243
cf0fc8ab 244 # Maybe the zone new hook did not exit correctly.
1848564d
MT
245 # If this is the case we remove the created zone immediately.
246 if [ "${ret}" = "${EXIT_ERROR}" ]; then
cf0fc8ab 247 zone_destroy_now "${zone}"
5c5b8e36 248 return ${EXIT_ERROR}
1848564d 249 fi
5c5b8e36
SS
250
251 # Automatically enable zone.
252 zone_enable "${zone}"
ac694a6a
MT
253
254 # Bring up the zone immediately after
255 zone_start "${zone}"
1848564d
MT
256}
257
1c6a4e30 258zone_edit() {
1848564d
MT
259 local zone=${1}
260 shift
261
262 if ! zone_exists ${zone}; then
263 error "Zone '${zone}' does not exist."
264 return ${EXIT_ERROR}
265 fi
266
69ace22b 267 # Check if the zone is tagged for removal.
cf0fc8ab 268 if zone_has_destroy_tag ${zone}; then
69ace22b
MT
269 error "You cannot edit a zone that is tagged for removal."
270 return ${EXIT_ERROR}
271 fi
272
2472e0ea 273 local hook="$(zone_get_hook "${zone}")"
1848564d
MT
274 if [ -z "${hook}" ]; then
275 error "Config file did not provide any hook."
276 return ${EXIT_ERROR}
277 fi
278
d61a01d4 279 if ! hook_zone_exists ${hook}; then
1848564d
MT
280 error "Hook '${hook}' does not exist."
281 return ${EXIT_ERROR}
282 fi
283
d61a01d4 284 hook_zone_exec ${hook} edit ${zone} $@
1848564d
MT
285}
286
2bb20bbd
SS
287zone_rename() {
288 assert [ $# -eq 2 ]
289
290 local zone="${1}"
291 local name="${2}"
292
293 assert zone_exists "${zone}"
294 assert not zone_has_destroy_tag "${zone}"
295 assert not zone_exists "${name}"
296
297 # The zone must be shut down before, is then renamed and
298 # potentially brought up again
299
300 # Save if the zone is running right now
301 zone_is_active "${zone}"
302 local zone_was_active="${?}"
303
304 # Save if the zone is enabled (i.e. auto-start)
305 zone_is_enabled "${zone}"
306 local zone_was_enabled="${?}"
307
308 # Stop the zone
309 zone_stop "${zone}"
310
311 # Disable the zone
312 zone_disable "${zone}"
313
314 # Rename the configuration files
315 mv -f "$(zone_dir "${zone}")" "$(zone_dir "${name}")"
316
317 # Enable the zone if it was enabled before
318 [ ${zone_was_enabled} -eq ${EXIT_TRUE} ] && zone_enable "${name}"
319
320 # Start the zone if it was up before
321 [ ${zone_was_active} -eq ${EXIT_TRUE} ] && zone_start "${name}"
322
323 log INFO "Zone ${zone} was renamed to ${name}"
324 return ${EXIT_OK}
325}
326
69ace22b 327
1c6a4e30 328zone_destroy() {
cf0fc8ab
MT
329 local zone="${1}"
330 assert zone_exists "${zone}"
1848564d 331
69ace22b 332 # Make the zone for removal.
cf0fc8ab 333 touch "$(zone_dir "${zone}")/.destroy"
69ace22b
MT
334
335 log INFO "Zone '${zone}' has been tagged for removal."
336}
337
1c6a4e30 338zone_has_destroy_tag() {
cf0fc8ab
MT
339 local zone="${1}"
340 assert zone_exists "${zone}"
69ace22b 341
cf0fc8ab 342 [ -e "$(zone_dir "${zone}")/.destroy" ]
69ace22b
MT
343}
344
345# This function will remove the given zone
cf0fc8ab 346# RIGHT NOW. Use zone_destroy to remove it
69ace22b 347# at the next status change.
1c6a4e30 348zone_destroy_now() {
cf0fc8ab
MT
349 local zone="${1}"
350 assert zone_exists "${zone}"
69ace22b
MT
351
352 log INFO "Removing zone '${zone}' right now."
1848564d 353
69ace22b 354 # Force the zone down.
d5c9bd17 355 zone_is_active "${zone}" && zone_stop "${zone}"
1848564d 356
5c5b8e36
SS
357 # Disable zone.
358 zone_disable "${zone}"
359
cf0fc8ab 360 rm -rf "$(zone_dir "${zone}")"
1848564d
MT
361}
362
1c6a4e30 363zone_up() {
1848564d
MT
364 local zone=${1}
365 shift
366
367 if ! zone_exists ${zone}; then
368 error "Zone '${zone}' does not exist."
369 return ${EXIT_ERROR}
370 fi
371
69ace22b 372 # Check if a zone has got the remove tag.
fa0eb21f 373 if zone_has_destroy_tag ${zone}; then
69ace22b
MT
374 error "Cannot bring up any zone which is to be removed."
375 return ${EXIT_ERROR}
376 fi
377
2472e0ea 378 local hook="$(zone_get_hook "${zone}")"
1848564d
MT
379 if [ -z "${hook}" ]; then
380 error "Config file did not provide any hook."
381 return ${EXIT_ERROR}
382 fi
383
d61a01d4 384 if ! hook_zone_exists ${hook}; then
1848564d
MT
385 error "Hook '${hook}' does not exist."
386 return ${EXIT_ERROR}
387 fi
388
059469a8
MT
389 zone_db ${zone} starting
390
d61a01d4
MT
391 hook_zone_exec ${hook} up ${zone} $@
392
059469a8 393 zone_db ${zone} started
de3cecef
MT
394
395 # Execute all triggers after the zone got up
396 triggers_execute_all "up" ZONE="${zone}"
1848564d
MT
397}
398
1c6a4e30 399zone_down() {
1848564d
MT
400 local zone=${1}
401 shift
402
403 if ! zone_exists ${zone}; then
404 error "Zone '${zone}' does not exist."
405 return ${EXIT_ERROR}
406 fi
407
2472e0ea 408 local hook="$(zone_get_hook "${zone}")"
1848564d
MT
409 if [ -z "${hook}" ]; then
410 error "Config file did not provide any hook."
411 return ${EXIT_ERROR}
412 fi
413
d61a01d4 414 if ! hook_zone_exists ${hook}; then
1848564d
MT
415 error "Hook '${hook}' does not exist."
416 return ${EXIT_ERROR}
417 fi
418
059469a8
MT
419 zone_db ${zone} stopping
420
d61a01d4 421 hook_zone_exec ${hook} down ${zone} $@
059469a8
MT
422
423 zone_db ${zone} stopped
69ace22b 424
de3cecef
MT
425 # Execute all triggers after the zone went down
426 triggers_execute_all "down" ZONE="${zone}"
427
69ace22b 428 # Remove the zone, if it has got a remove tag.
cf0fc8ab
MT
429 if zone_has_destroy_tag "${zone}"; then
430 zone_destroy_now "${zone}"
69ace22b 431 fi
1848564d
MT
432}
433
1c6a4e30 434zone_status() {
2472e0ea
MT
435 local zone="${1}"
436 assert isset zone
1848564d
MT
437 shift
438
2472e0ea 439 if ! zone_exists "${zone}"; then
1848564d
MT
440 error "Zone '${zone}' does not exist."
441 return ${EXIT_ERROR}
442 fi
443
2472e0ea 444 local hook="$(zone_get_hook "${zone}")"
1848564d
MT
445 if [ -z "${hook}" ]; then
446 error "Config file did not provide any hook."
447 return ${EXIT_ERROR}
448 fi
449
2472e0ea 450 if ! hook_zone_exists "${hook}"; then
1848564d
MT
451 error "Hook '${hook}' does not exist."
452 return ${EXIT_ERROR}
453 fi
454
2472e0ea 455 hook_zone_exec "${hook}" "status" "${zone}" "$@"
69ace22b
MT
456
457 # Show that the zone it to be removed soon.
fa0eb21f 458 if zone_has_destroy_tag ${zone}; then
69ace22b
MT
459 warning "This zone is tagged for removal."
460 fi
1848564d
MT
461}
462
f5ee091e
MT
463zone_identify() {
464 assert [ $# -ge 1 ]
465
466 local zone="${1}"
467 shift
468
469 assert zone_exists "${zone}"
470
471 log INFO "Identifying zone ${zone}"
472 local pids
473
474 local pid
475 local port
476 for port in $(zone_get_ports "${zone}"); do
477 # Identify all the ports
478 port_identify "${port}" --background $@
479
480 # Save the PIDs of the subprocesses
481 list_append pids "$(cmd_background_get_pid)"
482 done
483
484 # Wait until all port_identfy processes have finished
485 for pid in ${pids}; do
486 cmd_background_result "${pid}"
487 done
488
489 return ${EXIT_OK}
490}
491
1c6a4e30 492zone_get_ports() {
711ffac1
MT
493 local zone=${1}
494
495 assert isset zone
496
497 local port
943e3f7e 498 for port in $(zone_dir ${zone})/ports/*; do
711ffac1 499 port=$(basename ${port})
711ffac1
MT
500
501 if port_exists ${port}; then
502 echo "${port}"
503 fi
504 done
505}
506
1c6a4e30 507zone_get_ports_num() {
529141df
MT
508 local zone="${1}"
509 assert isset zone
510
511 local counter=0
512 local port
513 for port in $(zone_dir "${zone}")/ports/*; do
514 port="$(basename "${port}")"
515
516 if port_exists "${port}"; then
517 counter=$(( ${counter} + 1 ))
518 fi
519 done
520
521 echo "${counter}"
522 return ${EXIT_OK}
523}
524
1c6a4e30 525zone_has_port() {
3a7fef62
MT
526 # Check, if the given port is configured
527 # in this zone.
528
529 local zone=${1}
530 local port=${2}
531 shift 2
532
533 assert isset zone
534 assert isset port
535
536 [ -e "$(zone_dir ${zone})/ports/${port}" ]
537}
538
1c6a4e30 539zone_config() {
ea699552
MT
540 local zone="${1}"
541 local cmd="${2}"
a5ebb169
MT
542 shift 2
543
544 assert isset zone
ea699552
MT
545 assert isset cmd
546 assert zone_exists "${zone}"
a5ebb169 547
ea699552 548 case "${cmd}" in
2a6b2397
MT
549 new)
550 zone_config_new "${zone}" "$@"
551 ;;
552 destroy)
553 zone_config_destroy "${zone}" "$@"
a5ebb169 554 ;;
ea699552
MT
555 edit)
556 zone_config_edit "${zone}" "$@"
557 ;;
a5ebb169 558 *)
e6a03d56
JS
559 # Check is we get a valid id
560 # TODO This could be also a valid hid
561 local id=${cmd}
562
563 if zone_config_id_is valid ${zone} ${id} && [[ ${1} == "edit" ]]; then
564 shift 1
565 zone_config_edit "${zone}" "${id}""$@"
566 else
567 error "Unrecognized argument: ${cmd}"
568 cli_usage root-zone-config-subcommands
569 exit ${EXIT_ERROR}
570 fi
a5ebb169
MT
571 ;;
572 esac
573}
574
1c6a4e30 575zone_config_cmd() {
ea699552 576 assert [ $# -gt 2 ]
a5ebb169 577
ea699552
MT
578 local cmd="${1}"
579 local zone="${2}"
580 shift 2
581
582 local hook="$(zone_get_hook "${zone}")"
a5ebb169
MT
583 assert isset hook
584
ea699552
MT
585 hook_zone_exec "${hook}" "config_${cmd}" "${zone}" "$@"
586}
587
2a6b2397 588zone_config_new() {
44b8ade9
SS
589 local zone="${1}"
590 shift
591
592 # Create a new configuration, but exit when that was
593 # not successful.
594 zone_config_cmd "new" "${zone}" "$@" || return ${?}
595
596 # If the config could be created, we will try to bring
597 # it up if the zone is up, too.
598 if zone_is_up "${zone}"; then
599 zone_configs_up "${zone}"
600 fi
ea699552
MT
601}
602
2a6b2397
MT
603zone_config_destroy() {
604 zone_config_cmd "destroy" "$@"
ea699552
MT
605}
606
2a6b2397
MT
607zone_config_edit() {
608 zone_config_cmd "edit" "$@"
ea699552
MT
609}
610
1c6a4e30 611zone_config_show() {
ea699552 612 zone_config_cmd "show" "$@"
a5ebb169
MT
613}
614
1c6a4e30 615zone_show() {
1848564d
MT
616 local zone=${1}
617
618 echo "${zone}"
619 echo " Type: $(zone_get_hook ${zone})"
620 echo
621}
622
1c6a4e30 623zones_show() {
1848564d
MT
624 local zone
625
626 for zone in $(zones_get $@); do
627 zone_show ${zone}
628 done
629}
630
1c6a4e30 631zones_get_all() {
1848564d 632 local zone
d61a01d4 633 for zone in $(zone_dir)/*; do
1848564d
MT
634 zone=$(basename ${zone})
635 zone_exists ${zone} || continue
636
637 echo "${zone}"
03170817 638 done
1848564d
MT
639}
640
1ca5fe9f
JS
641zones_get_next_free() {
642 # This function return the next free zones.
643 # Example net0 upl0 upl1 are configured so the next free zones are:
644 # net1 upl2
645 local i
646 local zone_name
647 for zone_name in ${VALID_ZONES}; do
648 i=0
649
650 while true; do
651 local zone="${zone_name}${i}"
652 if ! zone_exists ${zone}; then
653 echo "${zone}"
654 break
655 fi
656 i=$(( i + 1 ))
657 done
658 done
659}
660
1c6a4e30 661zones_get_local() {
1848564d
MT
662 local zone
663 for zone in $(zones_get_all); do
664 zone_is_local ${zone} && echo "${zone}"
665 done
666}
667
1c6a4e30 668zones_get_nonlocal() {
1848564d
MT
669 local zone
670 for zone in $(zones_get_all); do
5e42d659 671 zone_is_nonlocal ${zone} && echo "${zone}"
1848564d
MT
672 done
673}
674
1c6a4e30 675zones_get() {
1848564d
MT
676 local local=1
677 local remote=1
678
679 local zones
680
681 while [ $# -gt 0 ]; do
682 case "${1}" in
683 --local-only)
684 local=1
685 remote=0
686 ;;
687 --remote-only)
688 local=0
689 remote=1
690 ;;
691 --all)
692 local=1
693 remote=1
694 ;;
695 *)
696 if zone_name_is_valid ${1}; then
697 zones="${zones} ${1}"
698 else
699 warning "Unrecognized argument '${1}'"
700 fi
701 ;;
702 esac
703 shift
704 done
705
706 if [ -n "${zones}" ]; then
707 local zone
708 for zone in ${zones}; do
709 zone_exists ${zone} && echo "${zone}"
710 done
711 exit ${EXIT_OK}
712 fi
713
714 if [ ${local} -eq 1 ] && [ ${remote} -eq 1 ]; then
715 zones_get_all
716 elif [ ${local} -eq 1 ]; then
717 zones_get_local
718 elif [ ${remote} -eq 1 ]; then
719 zones_get_nonlocal
720 fi
721}
722
1c6a4e30 723zone_ports_list() {
1848564d
MT
724 local zone=${1}
725
726 local port
a5ebb169 727 for port in $(zone_dir ${zone})/ports/*; do
1848564d
MT
728 [ -e "${port}" ] || continue
729
730 echo $(basename ${port})
03170817 731 done
1848564d
MT
732}
733
1c6a4e30 734zone_port_attach() {
ac694a6a
MT
735 local zone="${1}"
736 assert isset zone
737
738 local port="${2}"
739 assert isset port
740
741 shift 2
742
743 # Check if the port actually exists.
744 if ! port_exists "${port}"; then
745 error "Cannot attach port '${port}' which does not exist"
746 return ${EXIT_ERROR}
747 fi
748
749 # Check if the port is already connected to this or any other zone.
750 local z
751 for z in $(zones_get_all); do
752 if zone_has_port "${z}" "${port}"; then
753 error "Port '${port}' is already attached to zone '${z}'"
754 return ${EXIT_ERROR}
755 fi
756 done
757
758 local hook="$(zone_get_hook "${zone}")"
759 assert isset hook
760
f5ee091e 761 # Make the port briefly flash if supported
01a079e0
MT
762 if device_exists ${port}; then
763 port_identify "${port}" --background
764 fi
f5ee091e 765
ac694a6a
MT
766 hook_zone_exec "${hook}" "port_attach" "${zone}" "${port}" "$@"
767 local ret="${?}"
768
769 case "${ret}" in
770 ${EXIT_OK})
771 log INFO "${port} has been attached to ${zone}"
772
773 # Automatically connect the port
abba34c1 774 zone_port_start "${zone}" "${port}"
ac694a6a
MT
775 ;;
776 *)
777 log CRITICAL "${port} could not be attached to ${zone}"
778 ;;
779 esac
780
781 return ${ret}
782}
783
1c6a4e30 784zone_port_edit() {
ac694a6a
MT
785 local zone="${1}"
786 assert isset zone
787
788 local port="${2}"
789 assert isset port
790
791 shift 2
792
793 # Check if the port actually exists.
794 if ! port_exists "${port}"; then
795 error "Port '${port}' does not exist"
796 return ${EXIT_ERROR}
797 fi
798
799 # Check if the zone actually has this port.
800 if ! zone_has_port "${zone}" "${port}"; then
801 error "Port '${port}' is not attached to zone '${zone}'"
802 return ${EXIT_ERROR}
803 fi
804
805 local hook=$(zone_get_hook "${zone}")
806 assert isset hook
807
808 hook_zone_exec "${hook}" "port_edit" "${zone}" "${port}" "$@"
809}
810
1c6a4e30 811zone_port_detach() {
ac694a6a
MT
812 local zone="${1}"
813 assert isset zone
814
815 local port="${2}"
816 assert isset port
817
1848564d
MT
818 shift 2
819
ac694a6a
MT
820 # Check if the zone actually has this port.
821 if ! zone_has_port "${zone}" "${port}"; then
822 error "Port '${port}' is not attached to zone '${zone}'"
823 return ${EXIT_ERROR}
824 fi
825
826 local hook=$(zone_get_hook "${zone}")
827 assert isset hook
828
f5ee091e
MT
829 # Make the port briefly flash if supported
830 port_identify "${port}" --background
831
ac694a6a
MT
832 hook_zone_exec "${hook}" "port_detach" "${zone}" "${port}" "$@"
833 local ret="${?}"
834
835 case "${ret}" in
836 ${EXIT_OK})
837 log INFO "${port} has been detached from ${zone}"
838
839 # Bring down the port if needed
abba34c1 840 zone_port_stop "${zone}" "${port}"
ac694a6a
MT
841 ;;
842 *)
843 log CRITICAL "${port} could not be detached from ${zone}"
844 ;;
845 esac
846
847 return ${ret}
848}
849
1c6a4e30 850zone_port_cmd() {
ac694a6a 851 local cmd="${1}"
711ffac1 852 assert isset cmd
ac694a6a
MT
853
854 local zone="${2}"
711ffac1 855 assert isset zone
1848564d 856
ac694a6a
MT
857 local port="${3}"
858 assert isset port
1848564d 859
ac694a6a
MT
860 shift 3
861
862 local hook="$(zone_get_hook "${zone}")"
863 assert isset hook
864
865 # Dispatch command to hook
866 hook_zone_exec "${hook}" "${cmd}" "${zone}" "${port}" $@
867}
868
1c6a4e30 869zone_port_create() {
ac694a6a
MT
870 zone_port_cmd "port_create" $@
871}
872
1c6a4e30 873zone_port_remove() {
ac694a6a
MT
874 zone_port_cmd "port_remove" $@
875}
876
1c6a4e30 877zone_port_up() {
ac694a6a
MT
878 zone_port_cmd "port_up" $@
879}
880
1c6a4e30 881zone_port_down() {
ac694a6a
MT
882 zone_port_cmd "port_down" $@
883}
884
abba34c1
MT
885# The next two functions automagically bring up and down
886# port that are attached to a bridge or similar.
887# The problem that is tried to overcome here is that there
888# are ports which exist all the time (like ethernet ports)
889# and therefore do not dispatch a hotplug event when
890# port_create is called.
891
1c6a4e30 892zone_port_start() {
abba34c1
MT
893 local zone="${1}"
894 local port="${2}"
895
896 if zone_is_active "${zone}"; then
897 if device_exists "${port}"; then
898 zone_port_up "${zone}" "${port}"
899 return ${?}
900 else
901 zone_port_create "${zone}" "${port}"
902 return ${?}
903 fi
904 fi
905
906 return ${EXIT_OK}
907}
908
1c6a4e30 909zone_port_stop() {
abba34c1
MT
910 local zone="${1}"
911 local port="${2}"
912
913 # Shut down the port if necessary
914 if zone_is_active "${zone}" && port_is_up "${port}"; then
915 zone_port_down "${zone}" "${port}"
916 fi
917
918 # Remove the port
919 zone_port_remove "${zone}" "${port}"
920}
921
1c6a4e30 922zone_port_status() {
ac694a6a
MT
923 zone_port_cmd "port_status" $@
924}
925
1c6a4e30 926zone_ports_cmd() {
ac694a6a
MT
927 local cmd="${1}"
928 assert isset cmd
929
930 local zone="${2}"
931 assert isset zone
932
933 shift 2
934
935 local hook="$(zone_get_hook "${zone}")"
711ffac1
MT
936
937 local port
938 for port in $(zone_get_ports ${zone}); do
ac694a6a 939 hook_zone_exec "${hook}" "${cmd}" "${zone}" "${port}" $@
1848564d
MT
940 done
941}
942
1c6a4e30 943zone_ports_create() {
1ba6a2bb
MT
944 zone_ports_cmd "port_create" $@
945}
946
1c6a4e30 947zone_ports_remove() {
1ba6a2bb
MT
948 zone_ports_cmd "port_remove" $@
949}
950
1c6a4e30 951zone_ports_up() {
ac694a6a 952 zone_ports_cmd "port_up" $@
1848564d
MT
953}
954
1c6a4e30 955zone_ports_down() {
ac694a6a 956 zone_ports_cmd "port_down" $@
711ffac1
MT
957}
958
1c6a4e30 959zone_ports_status() {
ac694a6a 960 zone_ports_cmd "port_status" $@
1848564d
MT
961}
962
1c6a4e30 963zone_configs_cmd() {
2472e0ea 964 assert [ $# -ge 2 ]
ea699552
MT
965
966 local cmd="${1}"
967 local zone="${2}"
1848564d
MT
968 shift 2
969
ea699552 970 assert zone_exists "${zone}"
1848564d 971
1848564d 972 local config
2472e0ea
MT
973 for config in $(zone_configs_list "${zone}"); do
974 local config_hook="$(zone_config_get_hook "${zone}" "${config}")"
975 assert isset config_hook
976
977 hook_config_exec "${config_hook}" "${cmd}" "${zone}" "${config}" $@
1848564d
MT
978 done
979}
980
1c6a4e30 981zone_configs_up() {
ea699552 982 zone_configs_cmd "up" $@
1848564d
MT
983}
984
1c6a4e30 985zone_configs_down() {
ea699552 986 zone_configs_cmd "down" $@
1848564d
MT
987}
988
1c6a4e30 989zone_configs_status() {
ea699552
MT
990 zone_configs_cmd "status" $@
991}
992
1c6a4e30 993zone_configs_list() {
ea699552
MT
994 local zone=${1}
995
996 local config
997 for config in $(zone_dir ${zone})/configs/*; do
998 [ -e "${config}" ] || continue
999
1000 basename ${config}
1001 done
a5ebb169
MT
1002}
1003
0afedf0d
JS
1004zone_config_get_new_id() {
1005 # This functions returns the next free id for a zone
1006
1007 assert [ $# -eq 1 ]
1008 local zone=${1}
1009
1010 local zone_path=$(zone_dir ${zone})
1011 local i=0
1012
1013 while true; do
1014 if [ ! -f ${zone_path}/configs/*.${i} ]; then
1015 echo "${i}"
1016 return ${EXIT_OK}
1017 fi
1018 (( i++ ))
1019 done
1020}
1021
1c6a4e30 1022zone_config_get_hook() {
2472e0ea
MT
1023 assert [ $# -eq 2 ]
1024
1025 local zone="${1}"
1026 assert isset zone
1027
1028 local config="${2}"
1029 assert isset config
1030
1031 local HOOK
1032 zone_config_settings_read "${zone}" "${config}" \
1033 --ignore-superfluous-settings HOOK
1034
1035 print "${HOOK}"
1036}
1037
41f8233d
JS
1038zone_config_hook_is_configured() {
1039 # Checks if a zone has already at least one config with the given hook.
1040 # Returns True when yes and False when no
1041
1042 assert [ $# -eq 2 ]
1043 local zone=${1}
1044 local hook=${2}
1045
1046 local config
1047 for config in $(zone_configs_list "${zone}"); do
1048 local config_hook="$(zone_config_get_hook "${zone}" "${config}")"
1049 assert isset config_hook
1050 if [[ ${hook} == ${config_hook} ]]; then
1051 return ${EXIT_TRUE}
1052 fi
1053
1054 done
1055
1056 # If we get here the zone has no config with the given hook
1057 return ${EXIT_FALSE}
1058}
1059
f158dc66
JS
1060zone_config_id_is_valid() {
1061 # This function checks if a given id is valid for a zone
1062 # Return True when yes and false when no
1063
1064 assert [ $# -eq 2 ]
1065 local zone=${1}
1066 local id=${2}
1067
1068 local zone_path=$(zone_dir ${zone})
1069
1070 [ -f ${zone_path}/configs/*.${id} ];
1071}
1072
cdf4266d
JS
1073zone_config_get_hook_from_id() {
1074 # Returns the hook for a given id
1075 assert [ $# -eq 2 ]
1076 local zone=${1}
1077 local id=${2}
1078
1079 local config
1080 for config in $(zone_configs_list "${zone}"); do
1081 if [[ ${config} == *.${id} ]]; then
1082 local config_hook="$(zone_config_get_hook "${zone}" "${config}")"
1083 assert isset config_hook
1084 print "${config_hook}"
1085 return "${EXIT_OK}"
1086 fi
1087 done
1088
1089 # If we get here the zone has no config with the given id
1090 return ${EXIT_ERROR}
1091}
1092
1c6a4e30 1093zone_has_ip() {
38f61548 1094 device_has_ip $@
4231f419
MT
1095}
1096
1c6a4e30 1097zone_db() {
059469a8
MT
1098 local zone=${1}
1099 local action=${2}
1100 shift 2
1101
1102 case "${action}" in
1103 starting|started|stopping|stopped)
1104 db_connection_update ${zone} ${action}
1105 ;;
1106 esac
1107}
5e42d659 1108
1c6a4e30 1109zone_is_up() {
5e42d659
MT
1110 local zone=${1}
1111
1112 device_is_up ${zone}
1113}
1114
1c6a4e30 1115zone_is_down() {
5e42d659
MT
1116 ! zone_is_up $@
1117}
711ffac1 1118
1c6a4e30 1119zone_get_supported_port_hooks() {
711ffac1
MT
1120 local zone=${1}
1121
1122 local hook=$(zone_get_hook ${zone})
1123
1124 hook_zone_ports_get_all ${hook}
1125}
1126
1c6a4e30 1127zone_get_supported_config_hooks() {
ea699552 1128 hook_config_get_all
a5ebb169
MT
1129}
1130
1c6a4e30 1131zone_file() {
711ffac1
MT
1132 local zone=${1}
1133
1134 assert isset zone
1135
1136 echo "$(zone_dir ${zone})/settings"
1137}
1138
1c6a4e30 1139zone_settings_read() {
711ffac1 1140 local zone=${1}
711ffac1 1141 assert isset zone
52acd25f
MT
1142 shift
1143
1144 local args
1145 if [ $# -eq 0 ] && [ -n "${HOOK_SETTINGS}" ]; then
1146 list_append args ${HOOK_SETTINGS}
1147 else
1148 list_append args $@
1149 fi
711ffac1 1150
bfd6c282
MT
1151 # Save the HOOK variable.
1152 local hook="${HOOK}"
1153
52acd25f 1154 settings_read "$(zone_file "${zone}")" ${args}
bfd6c282
MT
1155
1156 # Restore hook.
1157 HOOK="${hook}"
711ffac1
MT
1158}
1159
1c6a4e30 1160zone_settings_write() {
1e6f187e 1161 local zone="${1}"
711ffac1
MT
1162 assert isset zone
1163
1e6f187e
MT
1164 local args
1165 if function_exists "hook_check_settings"; then
1166 list_append args "--check=\"hook_check_settings\""
1167 fi
1168 list_append args ${HOOK_SETTINGS}
1169
1170 settings_write "$(zone_file ${zone})" ${args}
711ffac1
MT
1171}
1172
1c6a4e30 1173zone_settings_set() {
711ffac1
MT
1174 local zone=${1}
1175 shift
1176 local args="$@"
1177
1178 assert isset zone
1179
1180 (
e9df08ad 1181 zone_settings_read ${zone}
711ffac1
MT
1182
1183 for arg in ${args}; do
1184 eval "${arg}"
1185 done
1186
e9df08ad 1187 zone_settings_write ${zone}
711ffac1
MT
1188 )
1189}
6b3f9c85 1190
1c6a4e30 1191zone_settings_get() {
6b3f9c85
MT
1192 local zone=${1}
1193 local key=${2}
1194
1195 assert isset zone
1196 assert isset key
1197
1198 (
1e6f187e
MT
1199 zone_settings_read "${zone}" "${key}" \
1200 --ignore-superfluous-settings
6b3f9c85
MT
1201
1202 echo "${!key}"
1203 )
1204}
e9df08ad 1205
1c6a4e30 1206zone_config_settings_read() {
c8132752 1207 assert [ $# -ge 2 ]
e9df08ad
MT
1208
1209 local zone="${1}"
1210 local config="${2}"
1211 shift 2
1212
c8132752
MT
1213 local args
1214 if [ $# -eq 0 ] && [ -n "${HOOK_CONFIG_SETTINGS}" ]; then
1215 list_append args ${HOOK_CONFIG_SETTINGS}
1216 else
1217 list_append args $@
1218 fi
1219
e9df08ad 1220 local path="$(zone_dir "${zone}")/configs/${config}"
c8132752 1221 settings_read "${path}" ${args}
e9df08ad
MT
1222}
1223
1c6a4e30 1224zone_config_settings_write() {
c8132752 1225 assert [ $# -ge 2 ]
e9df08ad
MT
1226
1227 local zone="${1}"
0959b0b9
JS
1228 local hook="${2}"
1229 local id=${3}
1230
1231 if ! isset id; then
1232 id=$(zone_config_get_new_id ${zone})
1233 log DEBUG "ID for the config is: ${id}"
1234 fi
e9df08ad 1235
c8132752
MT
1236 local args
1237 if function_exists "hook_check_config_settings"; then
1238 list_append args "--check=\"hook_check_config_settings\""
1239 fi
1240 list_append args ${HOOK_CONFIG_SETTINGS}
1241
0959b0b9 1242 local path="$(zone_dir "${zone}")/configs/${hook}.${id}"
c8132752 1243 settings_write "${path}" ${args}
e9df08ad
MT
1244}
1245
1c6a4e30 1246zone_port_settings_read() {
ac694a6a 1247 assert [ $# -ge 2 ]
e9df08ad
MT
1248
1249 local zone="${1}"
1250 local port="${2}"
1251 shift 2
1252
ac694a6a
MT
1253 local args
1254 if [ $# -eq 0 ] && [ -n "${HOOK_PORT_SETTINGS}" ]; then
1255 list_append args ${HOOK_PORT_SETTINGS}
1256 else
1257 list_append args $@
1258 fi
1259
e9df08ad 1260 local path="$(zone_dir "${zone}")/ports/${port}"
ac694a6a 1261 settings_read "${path}" ${args}
e9df08ad
MT
1262}
1263
1c6a4e30 1264zone_port_settings_write() {
02236ca6 1265 assert [ $# -ge 2 ]
e9df08ad
MT
1266
1267 local zone="${1}"
1268 local port="${2}"
1269 shift 2
1270
1e6f187e
MT
1271 local args
1272 if function_exists "hook_check_port_settings"; then
1273 list_append args "--check=\"hook_check_port_settings\""
1274 fi
ac694a6a 1275 list_append args ${HOOK_PORT_SETTINGS}
1e6f187e 1276
e9df08ad 1277 local path="$(zone_dir "${zone}")/ports/${port}"
1e6f187e 1278 settings_write "${path}" ${args}
e9df08ad
MT
1279}
1280
1c6a4e30 1281zone_port_settings_remove() {
e9df08ad
MT
1282 assert [ $# -eq 2 ]
1283
1284 local zone="${1}"
1285 local port="${2}"
1286
1287 local path="$(zone_dir "${zone}")/ports/${port}"
1288 settings_remove "${path}"
1289}
410d2e85
JS
1290
1291zone_get_color() {
1292 # This function return the color of a zone
1293 assert [ $# -eq 1 ]
1294
1295 local name=${1}
1296 color_read "zone" ${name}
1297}
5de34b4c
JS
1298
1299zone_get_description_title() {
1300 assert [ $# -eq 1 ]
1301
1302 local name=${1}
1303 description_title_read $(description_format_filename "zone" "${name}")
1304}